Convert

- Main Page
- Related Pages
- Modules
- Namespaces
- Data Structures
- Files
- Examples

Functions | Variables
Convert
Eina » Tools

These functions allow you to convert integer or real numbers to string or conversely. More...

## Functions
EAPI int | eina_convert_itoa (int n, char *s) EINA_ARG_NONNULL(2)
| Convert an integer number to a string in decimal base. More...
EAPI int | eina_convert_xtoa (unsigned int n, char *s) EINA_ARG_NONNULL(2)
| Convert an integer number to a string in hexadecimal base. More...
EAPI int | eina_convert_dtoa (double d, char *des) EINA_ARG_NONNULL(2)
| Convert a double to a string. More...
EAPI Eina_Bool | eina_convert_atod (const char *src, int length, long long *m, long *e) EINA_ARG_NONNULL(1
| Convert a string to a double. More...
EAPI Eina_Bool EAPI int | eina_convert_fptoa (Eina_F32p32 fp, char *des) EINA_ARG_NONNULL(2)
| Convert a 32.32 fixed point number to a string. More...
EAPI Eina_Bool | eina_convert_atofp (const char *src, int length, Eina_F32p32 *fp) EINA_ARG_NONNULL(1
| Convert a string to a 32.32 fixed point number. More...

## Variables
EAPI Eina_Error | EINA_ERROR_CONVERT_P_NOT_FOUND
| Not used, perhaps a placeholder? Defined as 0 in eina_convert.c.
EAPI Eina_Error | EINA_ERROR_CONVERT_0X_NOT_FOUND
| Not used, perhaps a placeholder? Defined as 0 in eina_convert.c.
EAPI Eina_Error | EINA_ERROR_CONVERT_OUTRUN_STRING_LENGTH
| Not used, perhaps a placeholder? Defined as 0 in eina_convert.c.

## Detailed Description

These functions allow you to convert integer or real numbers to string or conversely.

To use these functions, you have to call eina_init() first, and eina_shutdown() when eina is not used anymore.

# Conversion from integer to string

To convert an integer to a string in the decimal base, eina_convert_itoa() should be used. If the hexadecimal base is wanted, eina_convert_xtoa() should be used. They all need a buffer sufficiently large to store all the cyphers.

Here is an example of use:

#include <stdlib.h>
#include <stdio.h>
#include <Eina.h>
int main(void)
{
char tmp[128];
if (!eina_init())
{
printf ("Error during the initialization of eina.\n");
return EXIT_FAILURE;
}
eina_convert_itoa(45, tmp);
printf("value: %s\n", tmp);
eina_convert_xtoa(0xA1, tmp);
printf("value: %s\n", tmp);
eina_shutdown();
return EXIT_SUCCESS;
}

Compile this code with the following command:

gcc -Wall -o test_eina_convert test_eina.c `pkg-config --cflags --libs eina`

Note
  The alphabetical cyphers are in lower case.

# Conversion double / string

To convert a double to a string, eina_convert_dtoa() should be used. Like with the integer functions, a buffer must be used. The resulting string has the following format (which is the result obtained with snprintf() and the %a modifier):

[-]0xh.hhhhhp[+-]e

To convert a string to a double, eina_convert_atod() should be used. The format of the string must be as above. Then, the double has the following mantiss and exponent:

mantiss : [-]hhhhhh
exponent : 2^([+-]e - 4 * n)

with n being number of cypers after the point in the string format. To obtain the double number from the mantiss and exponent, use ldexp().

Here is an example of use:

#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <Eina.h>
int main(void)
{
char tmp[128];
long long int m = 0;
long int e = 0;
double r;
if (!eina_init())
{
printf ("Error during the initialization of eina.\n");
return EXIT_FAILURE;
}
printf("initial value : 40.56\n");
eina_convert_dtoa(40.56, tmp);
printf("result dtoa : %s\n", tmp);
eina_convert_atod(tmp, 128, &m, &e);
r = ldexp((double)m, e);
printf("result atod : %f\n", r);
eina_shutdown();
return EXIT_SUCCESS;
}

Compile this code with the following command:

gcc -Wall -o test_eina_convert test_eina.c `pkg-config --cflags --libs eina` -lm

## Function Documentation

EAPI int eina_convert_itoa | ( | int | n,
|  | char * | s
| ) |  |

Convert an integer number to a string in decimal base.

Parameters

  n | The integer to convert.
  s | The buffer to store the converted integer.

Returns
  The length of the string, including the nul terminated character.

This function converts `n` to a nul terminated string. The converted string is in decimal base. As no check is done, `s` must be a buffer that is sufficiently large to store the integer.

The returned value is the length of the string, including the nul terminated character.

Referenced by eet_node_dump(), eina_convert_dtoa(), eina_convert_fptoa(), and eina_xattr_int_set().

EAPI int eina_convert_xtoa | ( | unsigned int | n,
|  | char * | s
| ) |  |

Convert an integer number to a string in hexadecimal base.

Parameters

  n | The integer to convert.
  s | The buffer to store the converted integer.

Returns
  The length of the string, including the nul terminated character.

This function converts `n` to a nul terminated string. The converted string is in hexadecimal base and the alphabetical cyphers are in lower case. As no check is done, `s` must be a buffer that is sufficiently large to store the integer.

The returned value is the length of the string, including the nul terminated character.

EAPI int eina_convert_dtoa | ( | double | d,
|  | char * | des
| ) |  |

Convert a double to a string.

Parameters

  d | The double to convert.
  des | The destination buffer to store the converted double.

Returns
  EINA_TRUE on success, EINA_FALSE otherwise.

This function converts the double `d` to a string. The string is stored in the buffer pointed by `des` and must be sufficiently large to contain the converted double. The returned string is nul terminated and has the following format:

1 [-]0xh.hhhhhp[+-]e

where the h are the hexadecimal cyphers of the mantiss and e the exponent (a decimal number).

The returned value is the length of the string, including the nul character.

References eina_convert_itoa(), and EINA_FALSE.

Referenced by eina_xattr_double_set().

EAPI Eina_Bool eina_convert_atod | ( | const char * | src,
|  | int | length,
|  | long long * | m,
|  | long * | e
| ) |  |

Convert a string to a double.

Parameters

  src | The string to convert.
  length | The length of the string.
  m | The mantisse.
  e | The exponent.

Returns
  EINA_TRUE on success, EINA_FALSE otherwise.

This function converts the string `s` of length `length` that represent a double in hexadecimal base to a double. It is used to replace the use of snprintf() with the %a modifier, which is missing on some platform (like Windows (tm) or OpenBSD).

The string must have the following format:

1 [-]0xh.hhhhhp[+-]e

where the h are the hexadecimal cyphers of the mantiss and e the exponent (a decimal number). If n is the number of cypers after the point, the returned mantiss and exponents are:

1 mantiss : [-]hhhhhh
2 exponent : 2^([+-]e - 4 * n)

The mantiss and exponent are stored in the buffers pointed respectively by `m` and `e`.

If the string is invalid EINA_FALSE is returned, otherwise EINA_TRUE is returned.

Referenced by eina_xattr_double_get().

EAPI Eina_Bool EAPI int eina_convert_fptoa | ( | Eina_F32p32 | fp,
|  | char * | des
| ) |  |

Convert a 32.32 fixed point number to a string.

Parameters

  fp | The fixed point number to convert.
  des | The destination buffer to store the converted fixed point number.

Returns
  EINA_TRUE on success, EINA_FALSE otherwise.

This function converts the 32.32 fixed point number `fp` to a string. The string is stored in the buffer pointed by `des` and must be sufficiently large to contain the converted fixed point number. The returned string is terminated and has the following format:

1 [-]0xh.hhhhhp[+-]e

where the h are the hexadecimal cyphers of the mantiss and e the exponent (a decimal number).

The returned value is the length of the string, including the nul character.

Note
  The code is the same than eina_convert_dtoa() except that it implements the frexp() function for fixed point numbers and does some optimisations.

References eina_convert_itoa(), and EINA_FALSE.

EAPI Eina_Bool eina_convert_atofp | ( | const char * | src,
|  | int | length,
|  | Eina_F32p32 * | fp
| ) |  |

Convert a string to a 32.32 fixed point number.

Parameters

  src | The string to convert.
  length | The length of the string.
  fp | The fixed point number.

Returns
  EINA_TRUE on success, EINA_FALSE otherwise.

This function converts the string `src` of length `length` that represent a double in hexadecimal base to a 32.32 fixed point number stored in `fp`. The function always tries to convert the string with eina_convert_atod().

The string must have the following format:

1 [-]0xh.hhhhhp[+-]e

where the h are the hexadecimal cyphers of the mantiss and e the exponent (a decimal number). If n is the number of cypers after the point, the returned mantiss and exponents are:

1 mantiss : [-]hhhhhh
2 exponent : 2^([+-]e - 4 * n)

The mantiss and exponent are stored in the buffers pointed respectively by `m` and `e`.

If the string is invalid, EINA_FALSE is returned, otherwise `fp` is computed and EINA_TRUE is returned.

Note
  The code uses eina_convert_atod() and do the correct bit shift to compute the fixed point number.